> For the complete documentation index, see [llms.txt](https://docs.devolutions.net/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.devolutions.net/rdm/de/knowledge-base/troubleshooting-articles/test-secret-server-access-with-a-powershell-script.md).

# Secret Server-Zugriff mit einem PowerShell-Skript testen

Verwenden Sie ein PowerShell-Skript, um die Clientkonnektivität zur REST-API von Delinea Secret Server zu testen und zu bestätigen, dass die Geheimnissuche außerhalb von Remote Desktop Manager funktio

Wenn ein Eintrag ***Delinea Secret Server*** sich nicht authentifizieren kann oder keine Geheimnisse zurückgibt, zeigt ein Test der Verbindung außerhalb von Remote Desktop Manager, ob das Problem von der Arbeitsstation, vom Netzwerk oder vom Secret Server-Konto kommt. Remote Desktop Manager kommuniziert mit Secret Server über dessen REST-API: Es fordert ein OAuth2-Token von `<Secret Server URL>/oauth2/token` an und fragt dann `<Secret Server URL>/api/v1/secrets` ab. Das folgende PowerShell-Skript führt dieselben beiden Aufrufe aus.

1. Speichern Sie den folgenden Code in einer Datei namens `searchsecret.ps1`.
2. Ersetzen Sie die Werte von `$url`, `$username`, `$password` und `$domain` durch die URL und die Anmeldeinformationen Ihres Secret Server.
3. Ersetzen Sie den Wert von `$searchterm` durch den Namen oder einen Teil des Namens eines Geheimnisses, auf das Sie zugreifen können.
4. Führen Sie das Skript auf der Arbeitsstation aus, auf der Remote Desktop Manager installiert ist.

```powershell
$url = 'https://mysecretserver/SecretServer'
$username = 'myusername'
$password = 'mypassword'
$domain = 'mydomain'   # leave blank for local users

$searchterm = 'VPN'

# Request an OAuth2 token with the username and password.
$loginName = if ($domain) { "$domain\$username" } else { $username }
$body = @{
    username   = $loginName
    password   = $password
    grant_type = 'password'
}

try {
    $token = (Invoke-RestMethod -Method Post -Uri "$url/oauth2/token" -Body $body -ContentType 'application/x-www-form-urlencoded').access_token
}
catch {
    Write-Host 'Authentication failed:' $_.Exception.Message
    exit
}

# Search secrets with the search term, authenticating with the token.
Write-Host 'Searching for:' $searchterm
$headers = @{ Authorization = "Bearer $token" }
$query = 'filter.searchText=' + [uri]::EscapeDataString($searchterm)

try {
    $result = Invoke-RestMethod -Method Get -Uri "$url/api/v1/secrets?$query" -Headers $headers
    Write-Host 'Got search results:' $result.records.Count
    $result.records | ForEach-Object { Write-Host 'SecretId:' $_.id '  Name:' $_.name '  FolderId:' $_.folderId }
}
catch {
    Write-Host 'Search failed:' $_.Exception.Message
}
```

Wenn das Skript sich authentifiziert und Ihre Geheimnisse zurückgibt, kann die Arbeitsstation Secret Server erreichen, und das Problem liegt in der Konfiguration des Eintrags in Remote Desktop Manager. Wenn das Skript fehlschlägt, weist die Fehlermeldung auf das Netzwerk-, Zertifikat- oder Kontoproblem hin, das auf der Secret Server-Seite zu lösen ist.

{% hint style="info" %}
Wenn Ihr Secret Server-Konto eine Zwei-Faktor-Authentifizierung erfordert, schlägt die Tokenanforderung fehl, sofern Sie den Einmalcode nicht in einem `OTP`-Header hinzufügen, wie Remote Desktop Manager es tut.
{% endhint %}

### Siehe auch

* [Delinea Secret Server-Eintragseinstellungen](/rdm/de/knowledge-base/knowledge-base-articles/delinea-secret-server-entry-settings.md)


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.devolutions.net/rdm/de/knowledge-base/troubleshooting-articles/test-secret-server-access-with-a-powershell-script.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
